<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SEG_UsuarioSesion.xml */
/* Generado: 2020-08-18 04:21:30 */

/* Mantenimiento de los registros de la tabla SEG_UsuarioSesion */
abstract class BaseSEG_UsuarioSesionDP extends SEG_UsuarioSesionBV
{
    /* Constructor ( Establece los valores desde un objeto SEG_UsuarioSesionBN ) */
    public function __construct( SEG_UsuarioSesionBN $o_SEG_UsuarioSesionBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SEG_UsuarioSesionBN ) )
        {
            $this->setByBN( $o_SEG_UsuarioSesionBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SEG_UsuarioSesionBN */
    public function setByBN( SEG_UsuarioSesionBN $o_SEG_UsuarioSesionBN )
    {
        if ( !is_null( $o_SEG_UsuarioSesionBN->getId() ) )
        {
            $this->setId( $o_SEG_UsuarioSesionBN->getId() );
        }
        if ( !is_null( $o_SEG_UsuarioSesionBN->getIP() ) )
        {
            $this->setIP( $o_SEG_UsuarioSesionBN->getIP() );
        }
        if ( !is_null( $o_SEG_UsuarioSesionBN->getIdRol() ) )
        {
            $this->setIdRol( $o_SEG_UsuarioSesionBN->getIdRol() );
        }
        if ( !is_null( $o_SEG_UsuarioSesionBN->getIdUsuario() ) )
        {
            $this->setIdUsuario( $o_SEG_UsuarioSesionBN->getIdUsuario() );
        }
        if ( !is_null( $o_SEG_UsuarioSesionBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SEG_UsuarioSesionBN->getFechaCreacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SEG_UsuarioSesionFN = new SEG_UsuarioSesionFN();
        $o_SEG_UsuarioSesionBN = $o_SEG_UsuarioSesionFN->selectByPk( $this->getId() );
        if ( is_null( $o_SEG_UsuarioSesionBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SEG_UsuarioSesion ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Id";
                $s_SQLQuery2 .= $s_Separator."".$this->getId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIP() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IP";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIP()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRol() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRol";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdRol()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUsuario() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUsuario";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdUsuario()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SEG_UsuarioSesion SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIP() ) )
            {
                $s_SQLQuery .= $s_Separator."IP = '".$this->getIP()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRol() ) )
            {
                $s_SQLQuery .= $s_Separator."IdRol = '".$this->getIdRol()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUsuario() ) )
            {
                $s_SQLQuery .= $s_Separator."IdUsuario = '".$this->getIdUsuario()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  Id = ".$this->getId().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SEG_UsuarioSesion WHERE  Id = ".$this->getId().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>